'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.classesFor = undefined;

var _filter = require('ramda/src/filter');

var _filter2 = _interopRequireDefault(_filter);

var _toPairs = require('ramda/src/toPairs');

var _toPairs2 = _interopRequireDefault(_toPairs);

var _map = require('ramda/src/map');

var _map2 = _interopRequireDefault(_map);

var _apply = require('ramda/src/apply');

var _apply2 = _interopRequireDefault(_apply);

var _ifElse = require('ramda/src/ifElse');

var _ifElse2 = _interopRequireDefault(_ifElse);

var _curry = require('ramda/src/curry');

var _curry2 = _interopRequireDefault(_curry);

var _nth = require('ramda/src/nth');

var _nth2 = _interopRequireDefault(_nth);

var _is = require('ramda/src/is');

var _is2 = _interopRequireDefault(_is);

var _compose = require('ramda/src/compose');

var _compose2 = _interopRequireDefault(_compose);

var _mediaQueries = require('./media-queries');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hasMediaQuery = (0, _compose2.default)((0, _is2.default)(Object), (0, _nth2.default)(1));

var selectorFor = (0, _curry2.default)(function (prop, val) {
  return '' + prop + val;
});

var selectorWithMQFor = (0, _ifElse2.default)(hasMediaQuery, (0, _apply2.default)(_mediaQueries.mqObjToSelectors), (0, _apply2.default)(selectorFor));

/**
 * Get multiple tachyon classes
 * using an object where key is
 * selector type and value is value
 */
var classesFor = exports.classesFor = (0, _compose2.default)((0, _map2.default)(selectorWithMQFor), _toPairs2.default, (0, _filter2.default)(_utils.isPresent));