'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.displayName = exports.createEagerElement = exports.cx = exports.normalizeClassNames = exports.isPresent = undefined;

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

var _T = require('ramda/src/T');

var _T2 = _interopRequireDefault(_T);

var _call = require('ramda/src/call');

var _call2 = _interopRequireDefault(_call);

var _cond = require('ramda/src/cond');

var _cond2 = _interopRequireDefault(_cond);

var _flatten = require('ramda/src/flatten');

var _flatten2 = _interopRequireDefault(_flatten);

var _join = require('ramda/src/join');

var _join2 = _interopRequireDefault(_join);

var _concat = require('ramda/src/concat');

var _concat2 = _interopRequireDefault(_concat);

var _ = require('ramda/src/__');

var _2 = _interopRequireDefault(_);

var _contains = require('ramda/src/contains');

var _contains2 = _interopRequireDefault(_contains);

var _when = require('ramda/src/when');

var _when2 = _interopRequireDefault(_when);

var _map = require('ramda/src/map');

var _map2 = _interopRequireDefault(_map);

var _is = require('ramda/src/is');

var _is2 = _interopRequireDefault(_is);

var _ifElse = require('ramda/src/ifElse');

var _ifElse2 = _interopRequireDefault(_ifElse);

var _allPass = require('ramda/src/allPass');

var _allPass2 = _interopRequireDefault(_allPass);

var _type = require('ramda/src/type');

var _type2 = _interopRequireDefault(_type);

var _equals = require('ramda/src/equals');

var _equals2 = _interopRequireDefault(_equals);

var _compose = require('ramda/src/compose');

var _compose2 = _interopRequireDefault(_compose);

var _has = require('ramda/src/has');

var _has2 = _interopRequireDefault(_has);

var _isNil = require('ramda/src/isNil');

var _isNil2 = _interopRequireDefault(_isNil);

var _complement = require('ramda/src/complement');

var _complement2 = _interopRequireDefault(_complement);

exports.createWithStyleHoc = createWithStyleHoc;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isPresent = exports.isPresent = (0, _complement2.default)(_isNil2.default);
var hasPrototype = (0, _has2.default)('prototype');
var isReactComponent = (0, _compose2.default)((0, _equals2.default)('Object'), _type2.default, function (c) {
  return c.prototype.isReactComponent;
});
var isClassComponent = (0, _allPass2.default)([isPresent, hasPrototype, isReactComponent]);
var isNotClassComponent = (0, _complement2.default)(isClassComponent);
var doesNotHave = (0, _complement2.default)(_has2.default);

var mapIfObj = function mapIfObj(fn) {
  return (0, _ifElse2.default)((0, _is2.default)(Object), (0, _map2.default)(fn), fn);
};

var normalizeClassNames = exports.normalizeClassNames = function normalizeClassNames(options) {
  return mapIfObj((0, _when2.default)((0, _contains2.default)(_2.default, options), (0, _concat2.default)('-')));
};

/**
 * Compose classnames using deeply nested arrays of strings
 * or arrays of arrays of strings.
 */
var cx = exports.cx = (0, _compose2.default)((0, _join2.default)(' '), _flatten2.default);

/**
 * Eagerly excute a component if it is a
 * referentially transparent function component
 *
 * Based on the createEagerElementUtil in Andrew Clark's recompose library
 * github.com/acdlite/recompose/blob/master/src/packages/recompose/utils
 */
var isReferentiallyTransparentFunctionComponent = (0, _allPass2.default)([(0, _is2.default)(Function), isNotClassComponent, doesNotHave('defaultProps'), doesNotHave('contextTypes')]);

var createEagerElement = exports.createEagerElement = (0, _cond2.default)([[isReferentiallyTransparentFunctionComponent, _call2.default], [_T2.default, function (Component, props) {
  return _react2.default.createElement(Component, props);
}]]);

// construct the display name for a HOC
var displayName = exports.displayName = function displayName(component, name) {
  return name + '(' + (component.displayName || component.name || component) + ')';
};

/**
 * Create a withStyle HOC by
 * providing a transformation
 */
function createWithStyleHoc(_ref) {
  var name = _ref.name,
      transformation = _ref.transformation,
      propTypes = _ref.propTypes,
      component = _ref.component;

  function WithStyle(ownerProps) {
    var props = transformation(ownerProps);
    return createEagerElement(component, props);
  }

  WithStyle.displayName = displayName(component, name);
  WithStyle.propTypes = (0, _merge2.default)(component.propTypes, propTypes);

  return WithStyle;
}