'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withBackgroundColor = undefined;

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styleHelper = require('./style-helper');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var backgroundColorPropTypes = function backgroundColorPropTypes(colors) {
  return {
    bg: _propTypes2.default.oneOf(colors),
    className: _propTypes2.default.any
  };
};

function backgroundColorTransform(_ref) {
  var className = _ref.className,
      bg = _ref.bg,
      ownerProps = _objectWithoutProperties(_ref, ['className', 'bg']);

  return (0, _merge2.default)({ className: (0, _utils.cx)([(0, _styleHelper.classesFor)({ 'bg-': bg }), className]) }, ownerProps);
}

var withBackgroundColor = exports.withBackgroundColor = function withBackgroundColor(colors) {
  return function (component) {
    return (0, _utils.createWithStyleHoc)({
      name: 'withBackgroundColor',
      transformation: backgroundColorTransform,
      propTypes: backgroundColorPropTypes(colors),
      component: component
    });
  };
};