'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withColor = undefined;

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styleHelper = require('./style-helper');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var colorPropTypes = function colorPropTypes(colors) {
  return {
    color: _propTypes2.default.oneOf(colors),
    className: _propTypes2.default.any
  };
};

function colorTransform(_ref) {
  var className = _ref.className,
      color = _ref.color,
      ownerProps = _objectWithoutProperties(_ref, ['className', 'color']);

  return (0, _merge2.default)({ className: (0, _utils.cx)([(0, _styleHelper.classesFor)({ '': color }), className]) }, ownerProps);
}

var withColor = exports.withColor = function withColor(colors) {
  return function (component) {
    return (0, _utils.createWithStyleHoc)({
      name: 'withColor',
      transformation: colorTransform,
      propTypes: colorPropTypes(colors),
      component: component
    });
  };
};