'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mqObjToSelectors = exports.addMQSupport = exports.supportedSelectors = undefined;

var _toPairs = require('ramda/src/toPairs');

var _toPairs2 = _interopRequireDefault(_toPairs);

var _T = require('ramda/src/T');

var _T2 = _interopRequireDefault(_T);

var _cond = require('ramda/src/cond');

var _cond2 = _interopRequireDefault(_cond);

var _map = require('ramda/src/map');

var _map2 = _interopRequireDefault(_map);

var _curry = require('ramda/src/curry');

var _curry2 = _interopRequireDefault(_curry);

var _head = require('ramda/src/head');

var _head2 = _interopRequireDefault(_head);

var _equals = require('ramda/src/equals');

var _equals2 = _interopRequireDefault(_equals);

var _compose = require('ramda/src/compose');

var _compose2 = _interopRequireDefault(_compose);

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var supportedSelectors = exports.supportedSelectors = ['r', 'rounded', 'bw', 'ba', 'bt', 'br', 'bb', 'bl', 'bn', 'f', 'lh', 'h', 'w', 'pa', 'pl', 'pr', 'pb', 'pt', 'pv', 'ph', 'ma', 'ml', 'mr', 'mb', 'mt', 'mv', 'mh', 'na', 'nl', 'nr', 'nb', 'nt'];

var mqProp = function mqProp(propType) {
  return _propTypes2.default.shape({
    l: propType,
    m: propType,
    ns: propType,
    all: propType
  });
};

var addMQSupport = exports.addMQSupport = function addMQSupport(propType) {
  return _propTypes2.default.oneOfType([propType, mqProp(propType)]);
};

var mqType = function mqType(type) {
  return (0, _compose2.default)((0, _equals2.default)(type), _head2.default);
};
var mqSelector = function mqSelector(selector) {
  return function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        type = _ref2[0],
        val = _ref2[1];

    return '' + selector + val + '-' + type;
  };
};

var invalidMQ = function invalidMQ(selector) {
  return function () {
    throw new Error('Invalid media query type supplied to \'' + selector + '\'. It only supports all, ns, m & l.');
  };
};

var mqObjToSelectors = exports.mqObjToSelectors = (0, _curry2.default)(function (baseSelector, value) {
  return (0, _compose2.default)((0, _map2.default)((0, _cond2.default)([[mqType('all'), function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        val = _ref4[1];

    return '' + baseSelector + val;
  }], [mqType('ns'), mqSelector(baseSelector)], [mqType('m'), mqSelector(baseSelector)], [mqType('l'), mqSelector(baseSelector)], [_T2.default, invalidMQ(baseSelector)]])), _toPairs2.default)(value);
});