'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withBaseStyles = undefined;

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var sizePropTypes = {
  className: _propTypes2.default.any
};

var styleTransform = function styleTransform(baseStyles) {
  return function (_ref) {
    var className = _ref.className,
        ownerProps = _objectWithoutProperties(_ref, ['className']);

    return (0, _merge2.default)({ className: (0, _utils.cx)([baseStyles, className]) }, ownerProps);
  };
};

var withBaseStyles = exports.withBaseStyles = function withBaseStyles(styles) {
  return function (component) {
    return (0, _utils.createWithStyleHoc)({
      name: 'withBaseStyles',
      transformation: styleTransform(styles),
      propTypes: sizePropTypes,
      component: component
    });
  };
};